Attribute VB_Name = "DeScripter"
'Dieser Source stammt von http://www.goetz-reinecke.de und
'darf zur nicht kommerziellen Nutzung frei verwendet werden,
'solange diese Vermerke unverndert bleiben.
'(c) Gtz Reinecke Jan 2000
'
'Fr eventuelle Schden wird nicht gehaftet.
'
'Sollten Sie Fehler entdecken oder Fragen haben, dann
'mailen Sie mir bitte unter: vb@goetz-reinecke.de
'Ansonsten viel Spa und Erfolg damit !

Option Explicit

Public Type AproxiType
  TAG As String
  Start As Long
  Ende As Long
End Type

Public Type DeScripterType
  HTML As String
  Java As String
  VB As String
End Type

Private FORBIDDEN

Public Function ScriptSens(ByVal HTML$) As DeScripterType
  Dim SCRPT1&, SCRPT2&, UP$, Script$, POS&, TAG$, UPEXTR$
  Dim Aproxi As AproxiType, AFlag As Boolean, x&, y&, z&, AA$, BB$
     
    FORBIDDEN = Chr$(9) & Chr$(10) & Chr$(13) & Chr$(32) & Chr$(160)
    
    ScriptSens.HTML = HTML
    ScriptSens.Java = ""
    ScriptSens.VB = ""
    
    POS = 1
    Do
      POS = InStr(POS, UCase(HTML), "SCRIPT")
      If POS = 0 Then Exit Do
      Aproxi = AproximateTag(HTML, POS)
      TAG = RMEOL(Aproxi.TAG)
      
      If TAG = "" Then Exit Do
      UP = UCase(DeSpace(TAG, Chr$(34)))
      UPEXTR = UCase(DeSpace(TAG, ""))
      
      '### Test auf java
      If InStr(1, UCase(TAG), "JAVASCRIPT") Or (UP = "<SCRIPT>" And Script = "JAVA") Then
          If InStr(1, UCase(TAG), "JAVASCRIPT") Then Script = "JAVA"
          
          If Len(TAG) > 7 And (InStr(1, UP, "LANGUAGE=") <> 0 Or Left$(UP, 7) = "<SCRIPT") Then
              '<SCRIPT>
              POS = Aproxi.Ende + 1
              SCRPT1 = POS
              
              Do
                POS = InStr(POS, UCase(HTML), "SCRIPT")
                If POS = 0 Then Exit Function
                Aproxi = AproximateTag(HTML, POS)
                TAG = RMEOL(Aproxi.TAG)
                If TAG <> "" And UCase(DeSpace(TAG, Chr$(34))) = "</SCRIPT>" Then
                  ScriptSens.Java = ScriptSens.Java & _
                                    FormatScript(Mid$(HTML, SCRPT1, Aproxi.Start - SCRPT1))
                  '### Java aus HTML-Text elemenieren
                  HTML = Left$(HTML, SCRPT1 - 1) & Mid$(HTML, Aproxi.Ende + 1, Len(HTML))
                  ScriptSens.HTML = HTML
                  
                  POS = SCRPT1
                  Exit Do
                End If
                POS = Aproxi.Ende + 1
              Loop
              
          ElseIf InStr(1, UPEXTR, "JAVASCRIPT:") Then
              '### Java Aufruf aus TAG heraus
              SCRPT1 = 0
              For x = 1 To Len(TAG)
                BB = Mid$(TAG, x, 1)
                If (BB = Chr$(34) Or BB = "'") And AFlag = True Then
                  AFlag = False
                ElseIf (BB = Chr$(34) Or BB = "'") And AFlag = False Then
                  AFlag = True
                End If
                
                If AFlag = True And UCase(Mid$(TAG, x, 10)) = "JAVASCRIPT" Then
                  For y = x + 10 To Len(TAG)
                    BB = Mid$(TAG, y, 1)
                    If InStr(1, FORBIDDEN, BB) = 0 Then Exit For
                  Next y
                  If BB = ":" Then
                    For y = y + 1 To Len(TAG)
                      BB = Mid$(TAG, y, 1)
                      If InStr(1, FORBIDDEN, BB) = 0 Then Exit For
                    Next y
                    z = InStr(y + 1, TAG, Chr$(34))
                    If z < y Then
                      z = InStr(y + 1, TAG, "'")
                      If z = y Then z = Len(TAG) + 1
                    End If
                    AA = Mid$(TAG, y, z - y)
                    ScriptSens.Java = ScriptSens.Java & AA & Chr$(13) & Chr$(10)
                    '### Java aus HTML-Text elemenieren
                    HTML = Left$(HTML, Aproxi.Start - 1) & Mid$(HTML, Aproxi.Ende + 1, Len(HTML))
                    ScriptSens.HTML = HTML
                    x = y
                  End If
                End If
              Next x
              POS = Aproxi.Ende + 1
          Else
              GoTo NEIN
          End If
      End If
       
NEIN: POS = POS + Len(TAG)

    Loop
End Function

Private Function FormatScript(ByVal Script$) As String
  Dim Schrott$, x&, AA$
  
  Schrott = FORBIDDEN & "-" & ">" & "<" & "/" & "!"
  For x = 1 To Len(Script)
    AA = Mid$(Script, x, 1)
    If InStr(1, Schrott, AA) = 0 Then Exit For
  Next x
  Script = Mid$(Script, x, Len(Script))
  
  For x = Len(Script) To 1 Step -1
    AA = Mid$(Script, x, 1)
    If InStr(1, Schrott, AA) = 0 Then Exit For
  Next x
  
  FormatScript = Left$(Script, x) & Chr$(13) & Chr$(10)
End Function

Private Function AproximateTag(ByVal HTML$, ByVal POS&) As AproxiType
  Dim X1&, X2&, y&, AA$, BB$, T1&, T2&
    
    For y = POS + 1 To Len(HTML)
      BB = Mid$(HTML, y, 1)
      If BB = ">" Then X2 = y
      If BB = "<" And y > X2 And X2 <> 0 Then Exit For
    Next y
   
    
    AA = Left$(HTML, X2)
    
    X1 = 1
    For y = POS - 1 To 1 Step -1
      BB = Mid$(HTML, y, 1)
      If BB = "<" Then X1 = y
      If BB = ">" And X1 > 1 Then Exit For
    Next y
    
    AproximateTag.TAG = Mid$(HTML, X1, X2 - X1 + 1)
    AproximateTag.Start = X1
    AproximateTag.Ende = X2
End Function
